Total_time=max(Real_X_struct.time)



Real_X=Real_X_struct.signals.values';
Real_Y=Real_Y_struct.signals.values';
Plan_X=cell2mat(struct2cell(load('Plan_X.mat')));
Plan_Y=cell2mat(struct2cell(load('Plan_Y.mat')));
tunnel=cell2mat(struct2cell(load('tunnel.mat')));
obs_in=cell2mat(struct2cell(load('obs_in.mat')));
lenP=cell2mat(struct2cell(load('lenP.mat')));



plot(Plan_X,Plan_Y,'b');
hold on
plot(Real_X,Real_Y,'r');
for k=1:length(obs_in(:,1))
    plot_circle(obs_in(k,1),obs_in(k,2),obs_in(k,3));
end
[Xtu,Ytu]=myline(tunnel(1),tunnel(2),tunnel(3),tunnel(4));
plot(Xtu,Ytu,'*');


dev_sum=0;
for k=1:length(Plan_X)
    dis=min(sqrt((Plan_X(k)-Real_X).^2+(Plan_Y(k)-Real_Y).^2));
    if(dis>0.01)
        dev_sum=dev_sum+dis/lenP;
    end
end
CR=1-dev_sum/length(Plan_X)

