function [center1,CrossC1,center2,CrossC2,center]  = circlecenter(p1,p2,dRadius,turn)
k = (p2(2) - p1(2)) / (p2(1) - p1(1));
if k == 0
    center1(1) = (p1(1) + p2(1)) / 2.0;
    center2(1) = (p1(1) + p2(1)) / 2.0;
    center1(2) = p1(2) + sqrt(dRadius * dRadius -(p1(1) - p2(1)) * (p1(1) - p2(1)) / 4.0);
    center2(2) = p2(2) - sqrt(dRadius * dRadius -(p1(1) - p2(1)) * (p1(1) - p2(1)) / 4.0);
else
    k_verticle = -1.0 / k;
    mid_x = (p1(1) + p2(1)) / 2.0;
    mid_y = (p1(2) + p2(2)) / 2.0;
    a = 1.0 + k_verticle * k_verticle;
    b = -2 * mid_x - k_verticle * k_verticle * (p1(1) + p2(1));
    c = mid_x * mid_x + k_verticle * k_verticle * (p1(1) + p2(1)) * (p1(1) + p2(1)) / 4.0 - ...
    (dRadius * dRadius - ((mid_x - p1(1)) * (mid_x - p1(1)) + (mid_y - p1(2)) * (mid_y - p1(2))));

    center1(1) = (-1.0 * b + sqrt(b * b -4 * a * c)) / (2 * a);
    center2(1) = (-1.0 * b - sqrt(b * b -4 * a * c)) / (2 * a);
    center1(2) = k_verticle * center1(1) - k_verticle * mid_x + mid_y;
    center2(2) = k_verticle * center2(1) - k_verticle * mid_x + mid_y;
end
% жcenter1ת
P1C1 = p1 - center1;
P2C1 = p2 - center1;
P1C10 = [P1C1(1),P1C1(2),0];
P2C10 = [P2C1(1),P2C1(2),0];
CrossC1 = cross(P1C10,P2C10);
% жcenter2ת
P1C2 = p1 - center2;
P2C2 = p2 - center2;
P1C20 = [P1C2(1),P1C2(2),0];
P2C20 = [P2C2(1),P2C2(2),0];
CrossC2 = cross(P1C20,P2C20);
% turnʱΪ-1˳ʱΪ1
if CrossC1(3) ==0
    center = center1;
elseif sign(CrossC1(3)) == sign(turn)
    center = center1;
else 
    center = center2;
end

